Program Test;

Uses Pcx;

{$I VERSION.INC}

Var
  BitMap : Pointer;
  Pal : Palette;
  Size : Word;
  Diskfile : File;
  InName, OutName : String;

Procedure Help;

Begin
  Writeln('EXPAL - Palette Extractor v',VERSION_MAJOR,'.',VERSION_MINOR);
  Writeln('Usage: EXPAL <file>');
  Writeln('Options: (preceded by ''/'' or ''-'')');
  Writeln;
  Writeln('                 [File Specifiers]');
  Writeln('{file} specifies <infile> [outfile]');
  Writeln('   <infile>: input texture file (.PCX is default extention)');
  Writeln;
  Writeln('                 [Help]');
  Writeln(' [/h | /?]  displays this help.');
  Halt(0);
End;

Function UpStr(A : String) : String;

Var
  t : String;
  i : Integer;

Begin
  t := '';
  For i := 1 to Length(A) do
    T := T + UpCase(A[i]);
  UpStr := T;
End;


Begin
  If (ParamCount < 1)
    Then Help;

  InName := UpStr(ParamStr(1));
  if (Pos('.', InName) = 0)
    Then Insert('.PCX', InName, Length(InName)+1);

  OutName := InName;
  While(OutName[Length(OutName)] <> '.') do
    Delete(OutName, Length(OutName), 1);
  OutName := OutName + 'PAL';


  if (LoadPCXFile(InName, Bitmap, Pal, Size, 0) <> 0)
    Then Begin
      Writeln('Error loading PCX file.');
      Halt(0);
    End;
  Assign(Diskfile, OutName);
  {$I-}
  Rewrite(Diskfile, 1);
  {$I+}
  if (IOResult <> 0)
    Then Begin
      Writeln('Error writing Palette file.');
      Halt(0);
    End;

  BlockWrite(Diskfile, Pal, Sizeof(Palette));
  Close(Diskfile);
End.